/*
  Target table: 05_enriched_events
*/

SELECT
  r.event_time,
  r.event_day,
  r.event_hour,
  r.ed_app,
  r.event_type,
  r.event_action,
  r.actor_id,
  r.actor_ucdm_id,
  r.actor_sis_id,
  r.actor_lms_id,
  r.actor_login,
  r.actor_type,
  r.actor_name,
  r.course_offering_id,
  r.course_offering_ucdm_id,
  r.course_offering_lms_id,
  r.actor_role,
  r.object_id,
  r.object_type,
  r.object_entity,
  r.object_name,
  r.object_due_date,
  r.object_max_score,
  r.object_duration,
  r.object_entity_id,
  r.object_filename,
  r.object_mime_type,
  r.object_entity_type,
  r.object_topic_names,
  r.object_topic_slugs,
  r.is_part_of_id,
  r.is_part_of_type,
  r.is_part_of_entity,
  r.is_part_of_name,
  r.assignee_id,
  r.assignee_type,
  r.assignable_id,
  r.assignable_type,
  r.assignable_entity,
  r.generated_id,
  r.generated_type,
  r.generated_entity,
  r.generated_grade,
  r.generated_max_grade,
  r.generated_scored_by,
  r.target_id,
  r.target_type,
  r.target_watch_percentage,
  r.target_current_time,
  r.web_resource_location_type,
  r.web_resource_location_subtype,
  r.web_resource_location_name,
  r.launch_app_url,
  r.launch_app_domain,
  r.launch_app_name,
  r.is_tool,
  r.client_ip,
  i.longitude,
  i.latitude,
  i.location_point,
  i.city_name,
  i.subdivision_1_iso_code,
  i.subdivision_1_name,
  i.postal_code,
  i.country_iso_code,
  i.country_name,
  i.continent_code,
  i.continent_name,
  i.time_zone,
  co.academic_term_name,
  co.course_unique_name,
  co.course_offering_status,
  co.course_subject,
  co.course_number,
  co.course_code,
  co.course_title,
  co.course_student_enrollments,
  co.course_instructor_enrollments,
  CASE
    WHEN tn.tool_name IS NOT NULL THEN tn.tool_name
    WHEN tu.tool_name IS NOT NULL THEN tu.tool_name
    ELSE NULL
    END tool_name

FROM
  dataset.03_expanded_events r
LEFT JOIN dataset.1_course_offerings co USING(course_offering_lms_id)
LEFT JOIN dataset.4_ip_locations i ON r.client_ip=i.client_ip
LEFT JOIN dataset.map_tool_name tn ON r.launch_app_name=tn.name
LEFT JOIN dataset.map_tool_url tu ON r.launch_app_url=tu.url
